Index: binaries/data/config/default.cfg
===================================================================
--- binaries/data/config/default.cfg	(revision 17386)
+++ binaries/data/config/default.cfg	(working copy)
@@ -220,6 +220,10 @@
 ;9 =
 ;10 =
 
+[hotkey.loading]    ; > LOADING SCREEN TOOLTIP HOTKEYS
+previoustip = "LeftArrow"
+nexttip = "RightArrow"
+
 [hotkey.profile]
 toggle = "F11"               ; Enable/disable real-time profiler
 save = "Shift+F11"           ; Save current profiler data to logs/profile.txt
@@ -316,6 +320,9 @@
 cursorblinkrate = 0.5             ; Cursor blink rate in seconds (0.0 to disable blinking)
 scale = 1.0                       ; GUI scaling factor, for improved compatibility with 4K displays
 
+[gui.loadingtips]    ; > LOADING SCREEN TIP CONTROLS
+enabled = true
+
 [gui.menu]
 limitfps = true                   ; Limit FPS in the menus and loading screen
 
Index: binaries/data/mods/public/gui/gamesetup/gamesetup.js
===================================================================
--- binaries/data/mods/public/gui/gamesetup/gamesetup.js	(revision 17386)
+++ binaries/data/mods/public/gui/gamesetup/gamesetup.js	(working copy)
@@ -1168,7 +1168,8 @@
 		Engine.SwitchGuiPage("page_loading.xml", {
 			"attribs": g_GameAttributes,
 			"isNetworked" : g_IsNetworked,
-			"playerAssignments": g_PlayerAssignments
+			"playerAssignments": g_PlayerAssignments,
+			"isController": g_IsController
 		});
 	}
 }
Index: binaries/data/mods/public/gui/loading/loading.js
===================================================================
--- binaries/data/mods/public/gui/loading/loading.js	(revision 17386)
+++ binaries/data/mods/public/gui/loading/loading.js	(working copy)
@@ -1,4 +1,9 @@
-var g_Data;
+let g_Data;
+let tipControlsEnabled;
+let tips;
+let tipIndex;
+
+
 const END_PIECE_WIDTH = 16;
 
 function init(data)
@@ -5,65 +10,59 @@
 {
 	g_Data = data;
 
-	// Set to "hourglass" cursor.
-	Engine.SetCursor("cursor-wait");
+	if (!g_Data)
+		return;
 
-	// Get tip image and corresponding tip text
-	var tipTextLoadingArray = Engine.BuildDirEntList("gui/text/tips/", "*.txt", false);
+	// janwas: main loop now sets progress / description, but that won't
+	// happen until the first timeslice completes, so set initial values.
+	Engine.GetGUIObjectByName("loadingMapName").caption = sprintf(
+		data.attribs.mapType === "random" ? translate("Generating “%(map)s”") : translate("Loading “%(map)s”"),
+		{ "map": translate(data.attribs.settings.Name) });
 
-	if (tipTextLoadingArray.length > 0)
-	{
-		// Set tip text
-		var tipTextFilePath = tipTextLoadingArray[getRandom (0, tipTextLoadingArray.length-1)];
-		var tipText = Engine.TranslateLines(Engine.ReadFile(tipTextFilePath));
+	// Pick a random quote of the day (one quote per line).
+	let quoteArray = Engine.ReadFileLines("gui/text/quotes.txt");
+	Engine.GetGUIObjectByName("quoteText").caption = translate(quoteArray[getRandom(0, quoteArray.length-1)]);
 
-		if (tipText)
-		{
-			var index = tipText.indexOf("\n");
-			var tipTextTitle = tipText.substring(0, index);
-			var tipTextMessage = tipText.substring(index);
-			Engine.GetGUIObjectByName("tipTitle").caption = tipTextTitle? tipTextTitle : "";
-			Engine.GetGUIObjectByName("tipText").caption = tipTextMessage? tipTextMessage : "";
-		}
+	tips = Engine.BuildDirEntList("gui/text/tips/", "*.txt", false);
+	tipControlsEnabled = !data.isNetworked
+		&& Engine.ConfigDB_GetValue("user", "gui.loadingtips.enabled") === "true"
+		&& tips	&& tips.length > 0;
 
-		// Set tip image
-		var fileName = tipTextFilePath.substring(tipTextFilePath.lastIndexOf("/")+1).replace(".txt", ".png");
-		var tipImageFilePath = "loading/tips/" + fileName;
-		var sprite = "stretched:" + tipImageFilePath;
-		Engine.GetGUIObjectByName("tipImage").sprite = sprite? sprite : "";
-	}
-	else
-		error("Failed to find any matching tips for the loading screen.");
+	Engine.GetGUIObjectByName("prevTipButton").hidden = !tipControlsEnabled;
+	Engine.GetGUIObjectByName("nextTipButton").hidden = !tipControlsEnabled;
 
-	// janwas: main loop now sets progress / description, but that won't
-	// happen until the first timeslice completes, so set initial values.
-	var loadingMapName = Engine.GetGUIObjectByName("loadingMapName");
+	if (tips && tips.length > 0)
+		updateTip(getRandom(0, tips.length - 1));
+}
 
-	if (data)
-	{
-		var mapName = translate(data.attribs.settings.Name);
-		switch (data.attribs.mapType)
-		{
-		case "skirmish":
-		case "scenario":
-			loadingMapName.caption = sprintf(translate("Loading “%(map)s”"), { "map": mapName });
-			break;
+function nextTip()
+{
+	updateTip((tipIndex + 1) % tips.length);
+}
 
-		case "random":
-			loadingMapName.caption = sprintf(translate("Generating “%(map)s”"), { "map": mapName });
-			break;
+function prevTip()
+{
+	updateTip((tips.length + tipIndex - 1) % tips.length);
+}
 
-		default:
-			error("Unknown map type: " + data.attribs.mapType);
-		}
+function updateTip(nextTipIndex)
+{
+	// Set tip text
+	tipIndex = nextTipIndex;
+	let tipTextFilePath = tips[tipIndex];
+	let tipText	= Engine.TranslateLines(Engine.ReadFile(tipTextFilePath));
+	if (!tipText)
+	{
+		error("Failed to read tip text for the loading screen.");
+		return;
 	}
 
-	Engine.GetGUIObjectByName("progressText").caption = "";
-	Engine.GetGUIObjectByName("progressbar").caption = 0;
+	let index = tipText.indexOf("\n");
+	let fileName = tipTextFilePath.substring(tipTextFilePath.lastIndexOf("/")+1).replace(".txt", ".png");
 
-	// Pick a random quote of the day (each line is a separate tip).
-	var quoteArray = Engine.ReadFileLines("gui/text/quotes.txt");
-	Engine.GetGUIObjectByName("quoteText").caption = translate(quoteArray[getRandom(0, quoteArray.length-1)]);
+	Engine.GetGUIObjectByName("tipTitle").caption = tipText.substring(0, index);
+	Engine.GetGUIObjectByName("tipText").caption = tipText.substring(index);
+	Engine.GetGUIObjectByName("tipImage").sprite = "stretched:" + "loading/tips/" + fileName;
 }
 
 function displayProgress()
@@ -78,17 +77,14 @@
 	Engine.GetGUIObjectByName("progressbar").caption = progress; // display current progress
 	Engine.GetGUIObjectByName("progressText").caption = progress + "%";
 
-	// Displays detailed loading info rather than a percent
-	// Engine.GetGUIObjectByName("progressText").caption = g_LoadDescription; // display current progess details
-
 	// Keep curved right edge of progress bar in sync with the rest of the progress bar
-	var middle = Engine.GetGUIObjectByName("progressbar");
-	var rightSide = Engine.GetGUIObjectByName("progressbar_right");
+	let middle = Engine.GetGUIObjectByName("progressbar");
+	let rightSide = Engine.GetGUIObjectByName("progressbar_right");
 
-	var middleLength = (middle.size.right - middle.size.left) - (END_PIECE_WIDTH / 2);
-	var increment = Math.round(progress * middleLength / 100);
+	let middleLength = (middle.size.right - middle.size.left) - (END_PIECE_WIDTH / 2);
+	let increment = Math.round(progress * middleLength / 100);
 
-	var size = rightSide.size;
+	let size = rightSide.size;
 	size.left = increment;
 	size.right = increment + END_PIECE_WIDTH;
 	rightSide.size = size;
@@ -100,12 +96,29 @@
  */
 function reallyStartGame()
 {
-	// Switch GUI from loading screen to game session.
+	if (!tipControlsEnabled)
+	{
+		startGame();
+		return;
+	}
+
+	// Save the Camera Data
+	// TODO : Currently there is no function that returns the full camera position so if you zoom that will not be reset.
+	// We cannot prevent hotkeys from working because else the changing tooltip hotkeys wouldn't work.
+	g_Data.posZ = Engine.CameraGetZ();
+	g_Data.posX = Engine.CameraGetX();
+	// Pause the game so it doesn't run while we read tips
+	Engine.SetPaused(true);
+	Engine.GetGUIObjectByName("startGameButton").hidden = false;
+}
+
+function startGame()
+{
+	Engine.SetPaused(false);
+	Engine.CameraMoveTo(g_Data.posX,g_Data.posZ);
+	// Switch GUI from loading screen to game session
 	Engine.SwitchGuiPage("page_session.xml", g_Data);
 
-	// Restore default cursor.
-	Engine.SetCursor("arrow-default");
-	
 	// Notify the other clients that we have finished the loading screen
 	if (g_Data.isNetworked && g_Data.isRejoining)
 		Engine.SendNetworkRejoined();
Index: binaries/data/mods/public/gui/loading/loading.xml
===================================================================
--- binaries/data/mods/public/gui/loading/loading.xml	(revision 17386)
+++ binaries/data/mods/public/gui/loading/loading.xml	(working copy)
@@ -40,6 +40,19 @@
 		<object size="50%+128 50%-193 50%+448 50%+193" type="image" sprite="LoadingTipText">
 			<object name="tipTitle" size="30 30 100% 50" type="text" style="LoadingTipTitleText"/>
 			<object name="tipText" size="30 50 100%-30 100%" type="text" style="LoadingTipText"/>
+			
+			<!-- LOADING SCREEN TIP SHOW PREVIOUS -->
+			<object name="prevTipButton" type="button" size="20 100% 100 100%+30" z="99" hotkey="loading.previoustip" style="ModernButtonRed">
+				<translatableAttribute id="caption">Previous</translatableAttribute>
+				<action on="Press">prevTip();</action>
+			</object>
+
+			<!-- LOADING SCREEN TIP SHOW NEXT -->
+			<object name="nextTipButton" type="button" size="100%-90 100% 100%-30 100%+30" z="99" hotkey="loading.nexttip" style="ModernButtonRed">
+				<translatableAttribute id="caption">Next</translatableAttribute>
+				<action on="Press">nextTip();</action>
+			</object>
+
 		</object>
 
 		<!-- LOADING SCREEN QUOTE (needs increased z value to overcome the transparent area of the tip image above it -->
@@ -49,5 +62,13 @@
 			</object>
 			<object name="quoteText" size="0 30 100% 100%" type="text" style="LoadingText"></object>
 		</object>
+	
 	</object>
+
+	<!-- LOADING SCREEN READY (needs increased z value to overcome the quote area -->
+	<object name="startGameButton" type="button" size="50%-200 80%+80 50%+200 80%+120" z="99" hidden="true" hotkey="confirm" style="ModernButtonRed">
+		<translatableAttribute id="caption">I'm ready</translatableAttribute>
+		<action on="Press">startGame();</action>
+	</object>
+
 </objects>
Index: binaries/data/mods/public/gui/options/options.js
===================================================================
--- binaries/data/mods/public/gui/options/options.js	(revision 17386)
+++ binaries/data/mods/public/gui/options/options.js	(working copy)
@@ -15,6 +15,7 @@
 		[translate("Gametime Overlay"), translate("Show current simulation time in top right corner."), {"config":"gui.session.timeelapsedcounter"}, "boolean"],
 		[translate("Ceasefire Time Overlay"), translate("Always show the remaining ceasefire time."), {"config":"gui.session.ceasefirecounter"}, "boolean"],
 		[translate("Persist Match Settings"), translate("Save and restore match settings for quick reuse when hosting another game"), {"config":"persistmatchsettings"}, "boolean"],
+		[translate("Tip Controls"), translate("Allow navigating through loading screen tips and wait for the user before entering game."), {"config":"gui.loadingtips.enabled"}, "boolean"], 
 	],
 	"graphicsSetting":
 	[
@@ -116,7 +117,7 @@
 					case "config":
 						// Load initial value if not yet loaded.
 						if (!checked || typeof checked != "boolean")
-							checked = Engine.ConfigDB_GetValue("user", option[2][action]) === "true" ? true : false;
+							checked = Engine.ConfigDB_GetValue("user", option[2][action]) === "true";
 						// Hacky macro to create the callback.
 						var callback = function(key)
 						{